/*
 *****************************************************************************
 *                                                                           *
 *  Copyright Compaq Computer Corporation 1999.          All rights reserved.*
 *                                                                           *
 *****************************************************************************
*/
/*
 *      This is an example program to illustrate the 1D FFT 
 *              sfft(...)
 *      from a C application program.  The include file "cxmldef.h"
 *      maps the routine name to the platform-specific entrypoint
 *         e.g.  sfft(...) -> sfft_(...).
 *      The example shows the 
 *          - C array default index x[n] -> 0 to (n-1)
 *            vs. FORTRAN default   x(n) -> 1 to n
 *
 *      For more detailed explanation of the routine itself, please
 *      check the Reference Manual or manpage or the FORTRAN example
 *      program in this directory.
 */
   
#include <stdio.h>

#define SIZE 128
#include "cxmldef.h"


void main()
{
    float a[SIZE], b[SIZE]; 
    int   i, sz; 
    int   status, stride; 
  
  
    sz = SIZE; 
    status = 1; 
    stride = 1; 
  
    for (i=0; i<SIZE; i++)
        a[i] = i; 
  
    status = sfft("r", "c", "f", a, b, &sz, &stride); 
  
    printf("sfft() return code: %d\n", status);  
  
    if (status == 0)
        printf("Call sfft() successfully completed\n\n"); 
    else 
        printf("Error: check Reference Manual for error code description\n\n");

} /* end of main() */

