/*
 *****************************************************************************
 *                                                                           *
 *  Copyright Compaq Computer Corporation 1999.          All rights reserved.*
 *                                                                           *
 *****************************************************************************
*/
/*
 *      This is an example program to illustrate the 2D FFT 
 *              sfft_2d(...)
 *      from a C application program.    The include file "cxmldef.h"
 *      maps the routine name to the platform-specific entrypoint
 *         e.g.  sfft_2d(...) -> sfft_2d__(...).
 *      The example shows the 
 *          - C array default index x[n] -> 0 to (n-1)
 *            vs. FORTRAN default   x(n) -> 1 to n
 *
 *      For more detailed explanation of the routine itself, please
 *      check the Reference Manual or manpage or the FORTRAN example
 *      program in this directory.
 */
  
#include <stdio.h>

#define X_SIZE 		128
#define Y_SIZE 		128

float    a[(X_SIZE+2)*Y_SIZE],b[(X_SIZE+2)*Y_SIZE]; 

#include "cxmldef.h"



void main()
{
    int    i, j, k, status; 
    int	   Nx, Ny, Lda, sx, sy;   

    Nx = X_SIZE; 
    Ny = Y_SIZE; 
    Lda = X_SIZE + 2; 
    sx = sy = 1; 

    k = 0;  
    for (i = 0; i < X_SIZE; i++)
        for (j = 0; j < Y_SIZE; j++)
        {
            a[k] = k; 
	    k++; 
        }

    status = sfft_2d("R", "C", "F", a, b, &Nx, &Ny, &Lda, &sx, &sy); 

    printf("return code: %d\n", status);  
    if (status == 0)
        printf("Call sfft_2d() successfully completed\n\n");
    else
        printf("Error: check Reference Manual for error code description\n\n");

} /* end of main() */

