c
c*****************************************************************************
c*                                                                           *
c*  Copyright Compaq Computer Corporation 1999.         All rights reserved. *
c*                                                                           *
c*****************************************************************************

	PROGRAM EXAMPLE
	INCLUDE 'CXMLDEF.FOR'

	COMPLEX*8 A(8),OUTA(8),B(8),OUTB(8)
	COMPLEX*8 DIFF(8),W,G0,G1,AA
	REAL*4 TWOPI,T0
	INTEGER*4 T,K,I,NT,STATUS,N

	RECORD /DXML_C_FFT_STRUCTURE/ FFT_STRUCT

	N = 8
	TWOPI=6.283185307
	T0=TWOPI/FLOAT(8)
	W=CMPLX(COS(T0),(-1.0)*SIN(T0))		
	AA=(0.9,0.3)

C Compute the raw data for the transform
      B(1)=(1.0,0.0)
      DO 1 T=2,8
1     B(T)=AA**(T-1)

C Calculate the analytical transform of the function
      NT=8
      G0=(1.0,0.0)-AA**NT

      DO 5 I=1,NT
	G1=(1.0,0.0)-AA*(W**(I-1))
5	OUTA(I)=G0/G1

	TYPE 100
100   FORMAT(//,3X,'FOR REAL FORWARD FFT WITH 8 POINTS ',
     1  //,3X,'POINT',T11,'ANALYTICAL RESULT',T37,'COMPUTED RESULT',
     2  T65,'DIFF.',/)

C Compute the transform of the function using CXML routines
C This call should fail.
	ISTAT = CFFT_INIT (0,FFT_STRUCT,.TRUE.)
	IF (ISTAT.NE.DXML_SUCCESS()) CALL DXML_SIG_ERROR (ISTAT)

	ISTAT = CFFT_INIT (8,FFT_STRUCT,.TRUE.)
	IF (ISTAT.NE.DXML_SUCCESS()) CALL DXML_SIG_ERROR (ISTAT)

	ISTAT = CFFT_APPLY ('C','C','F',B,OUTB,FFT_STRUCT,1)
	IF (ISTAT.NE.DXML_SUCCESS()) CALL DXML_SIG_ERROR (ISTAT)

	ISTAT = CFFT_EXIT (FFT_STRUCT)
	IF (ISTAT.NE.DXML_SUCCESS()) CALL DXML_SIG_ERROR (ISTAT)

C Calculate the difference between the computed and analytical solution 
C to the transform 
      DO 10 I=1,NT
10    DIFF(I)=OUTB(I)-OUTA(I)

C Print out the results
      DO 20 I=1,NT
      TYPE 130,I,OUTA(I),OUTB(I),DIFF(I)
130   FORMAT(2X,I2,2X,3(2(1X,1PE11.4)))
20    CONTINUE

      STOP
      END
