! File: cxml_dss.f77
!
!  Copyright 2001 Compaq Computer Corporation
!
!  COMPAQ Registered in U.S. Patent and Trademark Office.
!
!  Confidential computer software.  Valid license from Compaq required for
!  possession, use or copying.  Consistent with FAR 12.211 and 12.212,
!  Commerical Computer Software, Computer Software Documentation, and
!  Technical Data for Commmerical Items are licensed to the U.S. Government
!  under vendor's standard commerical license.
!
!	Generated on: Tue Mar 27 21:23:07 2001
!
!



	STRUCTURE /CXML_DSS_HANDLE/
	    INTEGER*8 dummy
	END STRUCTURE

	INTEGER CXML_DSS_DEFAULTS
	PARAMETER ( CXML_DSS_DEFAULTS = 0 )


!
! Message level option definitions
!

	INTEGER CXML_DSS_MSG_LVL_SUCCESS
	PARAMETER ( CXML_DSS_MSG_LVL_SUCCESS = -2147483647 )

	INTEGER CXML_DSS_MSG_LVL_DEBUG  
	PARAMETER ( CXML_DSS_MSG_LVL_DEBUG   = -2147483646 )

	INTEGER CXML_DSS_MSG_LVL_INFO   
	PARAMETER ( CXML_DSS_MSG_LVL_INFO    = -2147483645 )

	INTEGER CXML_DSS_MSG_LVL_WARNING
	PARAMETER ( CXML_DSS_MSG_LVL_WARNING = -2147483644 )

	INTEGER CXML_DSS_MSG_LVL_ERROR  
	PARAMETER ( CXML_DSS_MSG_LVL_ERROR   = -2147483643 )

	INTEGER CXML_DSS_MSG_LVL_FATAL  
	PARAMETER ( CXML_DSS_MSG_LVL_FATAL   = -2147483642 )


!
! Termination level option definitions
!

	INTEGER CXML_DSS_TERM_LVL_SUCCESS
	PARAMETER ( CXML_DSS_TERM_LVL_SUCCESS = 1073741832 )

	INTEGER CXML_DSS_TERM_LVL_DEBUG  
	PARAMETER ( CXML_DSS_TERM_LVL_DEBUG   = 1073741840 )

	INTEGER CXML_DSS_TERM_LVL_INFO   
	PARAMETER ( CXML_DSS_TERM_LVL_INFO    = 1073741848 )

	INTEGER CXML_DSS_TERM_LVL_WARNING
	PARAMETER ( CXML_DSS_TERM_LVL_WARNING = 1073741856 )

	INTEGER CXML_DSS_TERM_LVL_ERROR  
	PARAMETER ( CXML_DSS_TERM_LVL_ERROR   = 1073741864 )

	INTEGER CXML_DSS_TERM_LVL_FATAL  
	PARAMETER ( CXML_DSS_TERM_LVL_FATAL   = 1073741872 )


!
! Structure option definitions
!

	INTEGER CXML_DSS_SYMMETRIC          
	PARAMETER ( CXML_DSS_SYMMETRIC           = 536870976 )

	INTEGER CXML_DSS_SYMMETRIC_STRUCTURE
	PARAMETER ( CXML_DSS_SYMMETRIC_STRUCTURE = 536871040 )

	INTEGER CXML_DSS_NON_SYMMETRIC      
	PARAMETER ( CXML_DSS_NON_SYMMETRIC       = 536871104 )


!
! Reordering option definitions
!

	INTEGER CXML_DSS_AUTO_ORDER   
	PARAMETER ( CXML_DSS_AUTO_ORDER    = 268435520 )

	INTEGER CXML_DSS_MY_ORDER     
	PARAMETER ( CXML_DSS_MY_ORDER      = 268435584 )

	INTEGER CXML_DSS_OPTION1_ORDER
	PARAMETER ( CXML_DSS_OPTION1_ORDER = 268435648 )


!
! Factorization option definitions
!

	INTEGER CXML_DSS_POSITIVE_DEFINITE          
	PARAMETER ( CXML_DSS_POSITIVE_DEFINITE           = 134217792 )

	INTEGER CXML_DSS_INDEFINITE                 
	PARAMETER ( CXML_DSS_INDEFINITE                  = 134217856 )

	INTEGER CXML_DSS_HERMITIAN_POSITIVE_DEFINITE
	PARAMETER ( CXML_DSS_HERMITIAN_POSITIVE_DEFINITE = 134217920 )

	INTEGER CXML_DSS_HERMITIAN_INDEFINITE       
	PARAMETER ( CXML_DSS_HERMITIAN_INDEFINITE        = 134217984 )


!
! Return status values
!

	INTEGER CXML_DSS_SUCCESS        
	PARAMETER ( CXML_DSS_SUCCESS         = 0 )

	INTEGER CXML_DSS_ZERO_PIVOT     
	PARAMETER ( CXML_DSS_ZERO_PIVOT      = -1 )

	INTEGER CXML_DSS_OUT_OF_MEMORY  
	PARAMETER ( CXML_DSS_OUT_OF_MEMORY   = -2 )

	INTEGER CXML_DSS_FAILURE        
	PARAMETER ( CXML_DSS_FAILURE         = -3 )

	INTEGER CXML_DSS_ROW_ERR        
	PARAMETER ( CXML_DSS_ROW_ERR         = -4 )

	INTEGER CXML_DSS_COL_ERR        
	PARAMETER ( CXML_DSS_COL_ERR         = -5 )

	INTEGER CXML_DSS_TOO_FEW_VALUES 
	PARAMETER ( CXML_DSS_TOO_FEW_VALUES  = -6 )

	INTEGER CXML_DSS_TOO_MANY_VALUES
	PARAMETER ( CXML_DSS_TOO_MANY_VALUES = -7 )

	INTEGER CXML_DSS_NOT_SQUARE     
	PARAMETER ( CXML_DSS_NOT_SQUARE      = -8 )

	INTEGER CXML_DSS_STATE_ERR      
	PARAMETER ( CXML_DSS_STATE_ERR       = -9 )

	INTEGER CXML_DSS_INVALID_OPTION 
	PARAMETER ( CXML_DSS_INVALID_OPTION  = -10 )

	INTEGER CXML_DSS_OPTION_CONFLICT
	PARAMETER ( CXML_DSS_OPTION_CONFLICT = -11 )

	INTEGER CXML_DSS_MSG_LVL_ERR    
	PARAMETER ( CXML_DSS_MSG_LVL_ERR     = -12 )

	INTEGER CXML_DSS_TERM_LVL_ERR   
	PARAMETER ( CXML_DSS_TERM_LVL_ERR    = -13 )

	INTEGER CXML_DSS_STRUCTURE_ERR  
	PARAMETER ( CXML_DSS_STRUCTURE_ERR   = -14 )

	INTEGER CXML_DSS_REORDER_ERR    
	PARAMETER ( CXML_DSS_REORDER_ERR     = -15 )

	INTEGER CXML_DSS_VALUES_ERR     
	PARAMETER ( CXML_DSS_VALUES_ERR      = -16 )


!
! Function prototypes for DSS routines
!

	INTEGER dss_create
	EXTERNAL dss_create

	INTEGER dss_define_structure
	EXTERNAL dss_define_structure

	INTEGER dss_reorder
	EXTERNAL dss_reorder

	INTEGER dss_factor_real
	EXTERNAL dss_factor_real

	INTEGER dss_factor_complex
	EXTERNAL dss_factor_complex

	INTEGER dss_solve_real
	EXTERNAL dss_solve_real

	INTEGER dss_solve_complex
	EXTERNAL dss_solve_complex

	INTEGER dss_delete
	EXTERNAL dss_delete

