/* File: dxml_def.h */
/*
**		       COPYRIGHT (C) 1997, 1999 BY
**	      DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASS.
**
** THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY BE USED AND  COPIED
** ONLY  IN  ACCORDANCE  WITH  THE  TERMS  OF  SUCH  LICENSE AND WITH THE
** INCLUSION OF THE ABOVE COPYRIGHT NOTICE.  THIS SOFTWARE OR  ANY  OTHER
** COPIES  THEREOF MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY
** OTHER PERSON.  NO TITLE TO AND OWNERSHIP OF  THE  SOFTWARE  IS  HEREBY
** TRANSFERRED.
**
** THE INFORMATION IN THIS SOFTWARE IS SUBJECT TO CHANGE  WITHOUT  NOTICE
** AND  SHOULD  NOT  BE  CONSTRUED  AS  A COMMITMENT BY DIGITAL EQUIPMENT
** CORPORATION.
**
** DIGITAL ASSUMES NO RESPONSIBILITY FOR THE USE OR  RELIABILITY  OF  ITS
** SOFTWARE ON EQUIPMENT WHICH IS NOT SUPPLIED BY DIGITAL.
**
**	Generated on: Tue Mar 27 21:51:53 2001
*/

#ifndef _DXML_DEF_H_
#define _DXML_DEF_H_
#if defined(__cplusplus)
extern "C"
{
#endif

/*
********************************************************************************
**
**	This include file contains the error code and the data structure
**	definitions for the DXML library
**
********************************************************************************
**
**	error code function declarations
*/

#define dxml_success dxml_success__
int dxml_success__( void );
#define dxml_mand_arg dxml_mand_arg__
int dxml_mand_arg__( void );
#define dxml_ill_temp_array dxml_ill_temp_array__
int dxml_ill_temp_array__( void );
#define dxml_in_version_skew dxml_in_version_skew__
int dxml_in_version_skew__( void );
#define dxml_ill_n_is_odd dxml_ill_n_is_odd__
int dxml_ill_n_is_odd__( void );
#define dxml_ill_wiggles dxml_ill_wiggles__
int dxml_ill_wiggles__( void );
#define dxml_ill_flow dxml_ill_flow__
int dxml_ill_flow__( void );
#define dxml_ill_f_range dxml_ill_f_range__
int dxml_ill_f_range__( void );
#define dxml_ill_n_range dxml_ill_n_range__
int dxml_ill_n_range__( void );
#define dxml_ill_n_nonrec dxml_ill_n_nonrec__
int dxml_ill_n_nonrec__( void );
#define dxml_ill_nterms dxml_ill_nterms__
int dxml_ill_nterms__( void );
#define dxml_ill_lda dxml_ill_lda__
int dxml_ill_lda__( void );
#define dxml_ins_res dxml_ins_res__
int dxml_ins_res__( void );
#define dxml_bad_stride dxml_bad_stride__
int dxml_bad_stride__( void );
#define dxml_direction_not_match dxml_direction_not_match__
int dxml_direction_not_match__( void );
#define dxml_bad_direction_string dxml_bad_direction_string__
int dxml_bad_direction_string__( void );
#define dxml_bad_format_string dxml_bad_format_string__
int dxml_bad_format_string__( void );
#define dxml_option_not_supported dxml_option_not_supported__
int dxml_option_not_supported__( void );
#define dxml_bad_format_for_direction dxml_bad_format_for_direction__
int dxml_bad_format_for_direction__( void );
#define dxml_ill_scal_vect_code dxml_ill_scal_vect_code__
int dxml_ill_scal_vect_code__( void );

/*
**	structure definitions
*/


typedef struct DXML_c_fft_structure {
	int n;
	int stride_1_flag;
	int n_ti[17];
	int n_k[17];
	int n_t[17];
	int type[17];
	int num_stages;
	float * rotation_vector;
	long rotation_vector_size;
	float * temp_area;
	long temp_area_size;
	int set_block_size;
	int num_non_special_radix;
	int non_special_radix[17];
	long non_spec_rad_twiddle_size;
	float * non_spec_rad_twiddle_vec;
	float * non_special_radix_cos[17];
	float * non_special_radix_sin[17];
	int num_processors;
	int future_use[20];
	int gk[12];
} DXML_C_FFT_STRUCTURE;

typedef struct DXML_s_fft_structure {
	int n;
	int stride_1_flag;
	DXML_C_FFT_STRUCTURE cv_struct;
	float * cos_recomb;
	float * sin_recomb;
	float * twiddle_recomb_pointer;
	long twiddle_recomb_size;
	int num_processors;
	int future_use[20];
} DXML_S_FFT_STRUCTURE;

typedef struct DXML_z_fft_structure {
	int n;
	int stride_1_flag;
	int n_ti[17];
	int n_k[17];
	int n_t[17];
	int type[17];
	int num_stages;
	double * rotation_vector;
	long rotation_vector_size;
	double * temp_area;
	long temp_area_size;
	int set_block_size;
	int num_non_special_radix;
	int non_special_radix[17];
	long non_spec_rad_twiddle_size;
	double * non_spec_rad_twiddle_vec;
	double * non_special_radix_cos[17];
	double * non_special_radix_sin[17];
	int num_processors;
	int future_use[20];
	int gk[12];
} DXML_Z_FFT_STRUCTURE;

typedef struct DXML_d_fft_structure {
	int n;
	int stride_1_flag;
	DXML_Z_FFT_STRUCTURE cv_struct;
	double * cos_recomb;
	double * sin_recomb;
	double * twiddle_recomb_pointer;
	long twiddle_recomb_size;
	int num_processors;
	int future_use[20];
} DXML_D_FFT_STRUCTURE;

typedef struct DXML_c_grp_fft_structure {
	int n;
	int grp_stride_1_flag;
	int grp_block_size;
	int n_ti[17];
	int n_k[17];
	int n_t[17];
	int type[17];
	int num_stages;
	float * rotation_vector;
	long rotation_vector_size;
	float * temp_area;
	long temp_area_size;
	int num_non_special_radix;
	int non_special_radix[17];
	long non_spec_rad_twiddle_size;
	float * non_spec_rad_twiddle_vec;
	float * non_special_radix_cos[17];
	float * non_special_radix_sin[17];
	int num_processors;
	int future_use[20];
	int gk[12];
} DXML_C_GRP_FFT_STRUCTURE;

typedef struct DXML_z_grp_fft_structure {
	int n;
	int grp_stride_1_flag;
	int grp_block_size;
	int n_ti[17];
	int n_k[17];
	int n_t[17];
	int type[17];
	int num_stages;
	double * rotation_vector;
	long rotation_vector_size;
	double * temp_area;
	long temp_area_size;
	int num_non_special_radix;
	int non_special_radix[17];
	long non_spec_rad_twiddle_size;
	double * non_spec_rad_twiddle_vec;
	double * non_special_radix_cos[17];
	double * non_special_radix_sin[17];
	int num_processors;
	int future_use[20];
	int gk[12];
} DXML_Z_GRP_FFT_STRUCTURE;

typedef struct DXML_s_grp_fft_structure {
	int n;
	int grp_stride_1_flag;
	DXML_C_GRP_FFT_STRUCTURE cv_struct;
	float * cos_recomb;
	float * sin_recomb;
	float * twiddle_recomb_pointer;
	long twiddle_recomb_size;
	int num_processors;
	int future_use[20];
} DXML_S_GRP_FFT_STRUCTURE;

typedef struct DXML_d_grp_fft_structure {
	int n;
	int grp_stride_1_flag;
	DXML_Z_GRP_FFT_STRUCTURE cv_struct;
	double * cos_recomb;
	double * sin_recomb;
	double * twiddle_recomb_pointer;
	long twiddle_recomb_size;
	int num_processors;
	int future_use[20];
} DXML_D_GRP_FFT_STRUCTURE;

typedef struct DXML_c_fft_structure_2d {
	DXML_C_FFT_STRUCTURE * x_structure_ptr;
	DXML_C_GRP_FFT_STRUCTURE * y_structure_ptr;
	int nx,ny;
	char x_type[16];
	long x_size,y_size;
	int stride_x_1_flag;
	float * temp_area;
	long temp_area_size;
	int num_processors;
	int future_use[20];
	int gk[12];
} DXML_C_FFT_STRUCTURE_2D;

typedef struct DXML_c_fft_structure_3d {
	DXML_C_FFT_STRUCTURE * x_structure_ptr;
	DXML_C_GRP_FFT_STRUCTURE * y_structure_ptr;
	DXML_C_GRP_FFT_STRUCTURE * z_structure_ptr;
	int nx,ny,nz;
	char x_type[16];
	long x_size,y_size,z_size;
	int stride_x_1_flag;
	float * temp_area;
	long temp_area_size;
	int num_processors;
	int future_use[20];
	int gk[12];
} DXML_C_FFT_STRUCTURE_3D;

typedef struct DXML_z_fft_structure_2d {
	DXML_Z_FFT_STRUCTURE * x_structure_ptr;
	DXML_Z_GRP_FFT_STRUCTURE * y_structure_ptr;
	int nx,ny;
	char x_type[16];
	long x_size,y_size;
	int stride_x_1_flag;
	double * temp_area;
	long temp_area_size;
	int num_processors;
	int future_use[20];
	int gk[12];
} DXML_Z_FFT_STRUCTURE_2D;

typedef struct DXML_z_fft_structure_3d {
	DXML_Z_FFT_STRUCTURE * x_structure_ptr;
	DXML_Z_GRP_FFT_STRUCTURE * y_structure_ptr;
	DXML_Z_GRP_FFT_STRUCTURE * z_structure_ptr;
	int nx,ny,nz;
	char x_type[16];
	long x_size,y_size,z_size;
	int stride_x_1_flag;
	double * temp_area;
	long temp_area_size;
	int num_processors;
	int future_use[20];
	int gk[12];
} DXML_Z_FFT_STRUCTURE_3D;

typedef struct DXML_s_fft_structure_2d {
	DXML_C_FFT_STRUCTURE * x_structure_ptr;
	DXML_C_GRP_FFT_STRUCTURE * y_structure_ptr;
	int nx,ny;
	char x_type[16];
	int y_grp_block_size,x_grp_block_size;
	long x_size,y_size;
	int stride_x_1_flag;
	float * cos_recomb;
	float * sin_recomb;
	float * twiddle_recomb_pointer;
	long twiddle_recomb_size;
	float * temp_area;
	long temp_area_size;
	int num_processors;
	int future_use[20];
	int gk[12];
} DXML_S_FFT_STRUCTURE_2D;

typedef struct DXML_s_fft_structure_3d {
	DXML_C_FFT_STRUCTURE * x_structure_ptr;
	DXML_C_GRP_FFT_STRUCTURE * y_structure_ptr;
	DXML_C_GRP_FFT_STRUCTURE * z_structure_ptr;
	int nx,ny,nz;
	char x_type[16];
	int z_grp_block_size,y_grp_block_size,x_grp_block_size;
	long x_size,y_size,z_size;
	int stride_x_1_flag;
	float * cos_recomb;
	float * sin_recomb;
	float * twiddle_recomb_pointer;
	long twiddle_recomb_size;
	float * temp_area;
	long temp_area_size;
	int num_processors;
	int future_use[20];
	int gk[12];
} DXML_S_FFT_STRUCTURE_3D;

typedef struct DXML_d_fft_structure_2d {
	DXML_Z_FFT_STRUCTURE * x_structure_ptr;
	DXML_Z_GRP_FFT_STRUCTURE * y_structure_ptr;
	int nx,ny;
	char x_type[16];
	int y_grp_block_size,x_grp_block_size;
	long x_size,y_size;
	int stride_x_1_flag;
	double * cos_recomb;
	double * sin_recomb;
	double * twiddle_recomb_pointer;
	long twiddle_recomb_size;
	double * temp_area;
	long temp_area_size;
	int num_processors;
	int future_use[20];
	int gk[12];
} DXML_D_FFT_STRUCTURE_2D;

typedef struct DXML_d_fft_structure_3d {
	DXML_Z_FFT_STRUCTURE * x_structure_ptr;
	DXML_Z_GRP_FFT_STRUCTURE * y_structure_ptr;
	DXML_Z_GRP_FFT_STRUCTURE * z_structure_ptr;
	int nx,ny,nz;
	char x_type[16];
	int z_grp_block_size,y_grp_block_size,x_grp_block_size;
	long x_size,y_size,z_size;
	int stride_x_1_flag;
	double * cos_recomb;
	double * sin_recomb;
	double * twiddle_recomb_pointer;
	long twiddle_recomb_size;
	double * temp_area;
	long temp_area_size;
	int num_processors;
	int future_use[20];
	int gk[12];
} DXML_D_FFT_STRUCTURE_3D;

typedef struct DXML_s_fht_structure {
	int n;
	int stride_1_flag;
	int n_ti[17];
	int n_k[17];
	int n_t[17];
	int type[17];
	int num_stages;
	float * rotation_vector;
	long rotation_vector_size;
	float * temp_area;
	long temp_area_size;
	int set_block_size;
	int num_non_special_radix;
	int non_special_radix[17];
	long non_spec_rad_twiddle_size;
	float * non_spec_rad_twiddle_vec;
	float * non_special_radix_cos[17];
	float * non_special_radix_sin[17];
	int num_processors;
	int future_use[20];
	int gk[12];
} DXML_S_FHT_STRUCTURE;

typedef struct DXML_s_fst_structure {
	DXML_S_FHT_STRUCTURE fht_struct;
	int N;
	int type;
	int stride_1_flag;
	float * twiddle_pointer;
	long twiddle_size;
	float * temp_array_ptr;
	int temp_array_size;
	int num_processors;
	int future_use[20];
} DXML_S_FST_STRUCTURE;

typedef struct DXML_s_fct_structure {
	DXML_S_FHT_STRUCTURE fht_struct;
	int N;
	int type;
	int stride_1_flag;
	float * twiddle_pointer;
	long twiddle_size;
	float * temp_array_ptr;
	int temp_array_size;
	int num_processors;
	int future_use[20];
} DXML_S_FCT_STRUCTURE;

typedef struct DXML_d_fht_structure {
	int n;
	int stride_1_flag;
	int n_ti[17];
	int n_k[17];
	int n_t[17];
	int type[17];
	int num_stages;
	double * rotation_vector;
	long rotation_vector_size;
	double * temp_area;
	long temp_area_size;
	int set_block_size;
	int num_non_special_radix;
	int non_special_radix[17];
	long non_spec_rad_twiddle_size;
	double * non_spec_rad_twiddle_vec;
	double * non_special_radix_cos[17];
	double * non_special_radix_sin[17];
	int num_processors;
	int future_use[20];
	int gk[12];
} DXML_D_FHT_STRUCTURE;

typedef struct DXML_d_fst_structure {
	DXML_D_FHT_STRUCTURE fht_struct;
	int N;
	int type;
	int stride_1_flag;
	double * twiddle_pointer;
	long twiddle_size;
	double * temp_array_ptr;
	int temp_array_size;
	int num_processors;
	int future_use[20];
} DXML_D_FST_STRUCTURE;

typedef struct DXML_d_fct_structure {
	DXML_D_FHT_STRUCTURE fht_struct;
	int N;
	int type;
	int stride_1_flag;
	double * twiddle_pointer;
	long twiddle_size;
	double * temp_array_ptr;
	int temp_array_size;
	int num_processors;
	int future_use[20];
} DXML_D_FCT_STRUCTURE;

typedef struct DXML_s_conv_corr_structure {
	int n_a,n_b,n_sig,n_good_value;
	float * a_work_ptr;
	float * b_work_ptr;
	float * work_ptr;
	int work_size;
	DXML_S_FFT_STRUCTURE fft_struct;
} DXML_S_CONV_CORR_STRUCTURE;

typedef struct DXML_d_conv_corr_structure {
	int n_a,n_b,n_sig,n_good_value;
	double * a_work_ptr;
	double * b_work_ptr;
	double * work_ptr;
	int work_size;
	DXML_D_FFT_STRUCTURE fft_struct;
} DXML_D_CONV_CORR_STRUCTURE;

typedef struct DXML_c_conv_corr_structure {
	int n_a,n_b,n_sig,n_good_value;
	float * a_work_ptr;
	float * b_work_ptr;
	float * work_ptr;
	int work_size;
	DXML_S_FFT_STRUCTURE fft_struct;
} DXML_C_CONV_CORR_STRUCTURE;

typedef struct DXML_z_conv_corr_structure {
	int n_a,n_b,n_sig,n_good_value;
	double * a_work_ptr;
	double * b_work_ptr;
	double * work_ptr;
	int work_size;
	DXML_D_FFT_STRUCTURE fft_struct;
} DXML_Z_CONV_CORR_STRUCTURE;

/*
**	Function type definition for the SIGNAL PROCESSING routines
*/

/*
**	Function type definition for the static signature FFT routines
*/
#define cfft_init cfft_init__
int cfft_init__( int *, DXML_C_FFT_STRUCTURE *, int * );
#define cfft_exit cfft_exit__
int cfft_exit__( DXML_C_FFT_STRUCTURE * );
#define zfft_init zfft_init__
int zfft_init__( int *, DXML_Z_FFT_STRUCTURE *, int * );
#define zfft_exit zfft_exit__
int zfft_exit__( DXML_Z_FFT_STRUCTURE * );
#define sfft sfft_
int sfft_( char *, char *, char *, float *, float *, int *, int * );
#define sfft_init sfft_init__
int sfft_init__( int *, DXML_S_FFT_STRUCTURE *, int * );
#define sfft_apply sfft_apply__
int sfft_apply__( char *, char *, char *, float *, float *, DXML_S_FFT_STRUCTURE 
	*, int * );
#define sfft_exit sfft_exit__
int sfft_exit__( DXML_S_FFT_STRUCTURE * );
#define dfft dfft_
int dfft_( char *, char *, char *, double *, double *, int *, int * );
#define dfft_init dfft_init__
int dfft_init__( int *, DXML_D_FFT_STRUCTURE *, int * );
#define dfft_apply dfft_apply__
int dfft_apply__( char *, char *, char *, double *, double *, 
	DXML_D_FFT_STRUCTURE *, int * );
#define dfft_exit dfft_exit__
int dfft_exit__( DXML_D_FFT_STRUCTURE * );
/*
**	Function type definition of the FHT routines
*/
#define sfct sfct_
int sfct_( char *, float *, float *, int *, int *, int * );
#define sfct_init sfct_init__
int sfct_init__( int *, DXML_S_FCT_STRUCTURE *, int *, int * );
#define sfct_apply sfct_apply__
int sfct_apply__( char *, float *, float *, DXML_S_FCT_STRUCTURE *, int * );
#define sfct_exit sfct_exit__
int sfct_exit__( DXML_S_FCT_STRUCTURE * );
#define dfct dfct_
int dfct_( char *, double *, double *, int *, int *, int * );
#define dfct_init dfct_init__
int dfct_init__( int *, DXML_D_FCT_STRUCTURE *, int *, int * );
#define dfct_apply dfct_apply__
int dfct_apply__( char *, double *, double *, DXML_D_FCT_STRUCTURE *, int * );
#define dfct_exit dfct_exit__
int dfct_exit__( DXML_D_FCT_STRUCTURE * );
#define sfst sfst_
int sfst_( char *, float *, float *, int *, int *, int * );
#define sfst_init sfst_init__
int sfst_init__( int *, DXML_S_FST_STRUCTURE *, int *, int * );
#define sfst_apply sfst_apply__
int sfst_apply__( char *, float *, float *, DXML_S_FST_STRUCTURE *, int * );
#define sfst_exit sfst_exit__
int sfst_exit__( DXML_S_FST_STRUCTURE * );
#define dfst dfst_
int dfst_( char *, double *, double *, int *, int *, int * );
#define dfst_init dfst_init__
int dfst_init__( int *, DXML_D_FST_STRUCTURE *, int *, int * );
#define dfst_apply dfst_apply__
int dfst_apply__( char *, double *, double *, DXML_D_FST_STRUCTURE *, int * );
#define dfst_exit dfst_exit__
int dfst_exit__( DXML_D_FST_STRUCTURE * );
/*
**	Function type definition for the static signature GRP FFT routines
*/
#define cfft_init_grp cfft_init_grp__
int cfft_init_grp__( int *, DXML_C_GRP_FFT_STRUCTURE *, int *, int * );
#define cfft_exit_grp cfft_exit_grp__
int cfft_exit_grp__( DXML_C_GRP_FFT_STRUCTURE * );
#define zfft_init_grp zfft_init_grp__
int zfft_init_grp__( int *, DXML_Z_GRP_FFT_STRUCTURE *, int *, int * );
#define zfft_exit_grp zfft_exit_grp__
int zfft_exit_grp__( DXML_Z_GRP_FFT_STRUCTURE * );
#define sfft_grp sfft_grp__
int sfft_grp__( char *, char *, char *, float *, float *, int *, int *, int *, 
	int *, int * );
#define sfft_init_grp sfft_init_grp__
int sfft_init_grp__( int *, DXML_S_GRP_FFT_STRUCTURE *, int *, int * );
#define sfft_apply_grp sfft_apply_grp__
int sfft_apply_grp__( char *, char *, char *, float *, float *, int *, int *, 
	DXML_S_GRP_FFT_STRUCTURE *, int *, int * );
#define sfft_exit_grp sfft_exit_grp__
int sfft_exit_grp__( DXML_S_GRP_FFT_STRUCTURE * );
#define dfft_grp dfft_grp__
int dfft_grp__( char *, char *, char *, double *, double *, int *, int *, int *, 
	int *, int * );
#define dfft_init_grp dfft_init_grp__
int dfft_init_grp__( int *, DXML_D_GRP_FFT_STRUCTURE *, int *, int * );
#define dfft_apply_grp dfft_apply_grp__
int dfft_apply_grp__( char *, char *, char *, double *, double *, int *, int *, 
	DXML_D_GRP_FFT_STRUCTURE *, int *, int * );
#define dfft_exit_grp dfft_exit_grp__
int dfft_exit_grp__( DXML_D_GRP_FFT_STRUCTURE * );
/*
**	Function type definition for the static signature 2D FFT routines
*/
#define cfft_init_2d cfft_init_2d__
int cfft_init_2d__( int *, int *, DXML_C_FFT_STRUCTURE_2D *, int * );
#define cfft_exit_2d cfft_exit_2d__
int cfft_exit_2d__( DXML_C_FFT_STRUCTURE_2D * );
#define zfft_init_2d zfft_init_2d__
int zfft_init_2d__( int *, int *, DXML_Z_FFT_STRUCTURE_2D *, int * );
#define zfft_exit_2d zfft_exit_2d__
int zfft_exit_2d__( DXML_Z_FFT_STRUCTURE_2D * );
#define sfft_2d sfft_2d__
int sfft_2d__( char *, char *, char *, float *, float *, int *, int *, int *, 
	int *, int * );
#define sfft_init_2d sfft_init_2d__
int sfft_init_2d__( int *, int *, DXML_S_FFT_STRUCTURE_2D *, int * );
#define sfft_apply_2d sfft_apply_2d__
int sfft_apply_2d__( char *, char *, char *, float *, float *, int *, 
	DXML_S_FFT_STRUCTURE_2D *, int *, int * );
#define sfft_exit_2d sfft_exit_2d__
int sfft_exit_2d__( DXML_S_FFT_STRUCTURE_2D * );
#define dfft_2d dfft_2d__
int dfft_2d__( char *, char *, char *, double *, double *, int *, int *, int *, 
	int *, int * );
#define dfft_init_2d dfft_init_2d__
int dfft_init_2d__( int *, int *, DXML_D_FFT_STRUCTURE_2D *, int * );
#define dfft_apply_2d dfft_apply_2d__
int dfft_apply_2d__( char *, char *, char *, double *, double *, int *, 
	DXML_D_FFT_STRUCTURE_2D *, int *, int * );
#define dfft_exit_2d dfft_exit_2d__
int dfft_exit_2d__( DXML_D_FFT_STRUCTURE_2D * );
/*
**	Function type definition for the static signature 3D FFT routines
*/
#define cfft_init_3d cfft_init_3d__
int cfft_init_3d__( int *, int *, int *, DXML_C_FFT_STRUCTURE_3D *, int * );
#define cfft_exit_3d cfft_exit_3d__
int cfft_exit_3d__( DXML_C_FFT_STRUCTURE_3D * );
#define zfft_init_3d zfft_init_3d__
int zfft_init_3d__( int *, int *, int *, DXML_Z_FFT_STRUCTURE_3D *, int * );
#define zfft_exit_3d zfft_exit_3d__
int zfft_exit_3d__( DXML_Z_FFT_STRUCTURE_3D * );
#define sfft_3d sfft_3d__
int sfft_3d__( char *, char *, char *, float *, float *, int *, int *, int *, 
	int *, int *, int *, int * );
#define sfft_init_3d sfft_init_3d__
int sfft_init_3d__( int *, int *, int *, DXML_S_FFT_STRUCTURE_3D *, int * );
#define sfft_apply_3d sfft_apply_3d__
int sfft_apply_3d__( char *, char *, char *, float *, float *, int *, int *, 
	DXML_S_FFT_STRUCTURE_3D *, int *, int *, int * );
#define sfft_exit_3d sfft_exit_3d__
int sfft_exit_3d__( DXML_S_FFT_STRUCTURE_3D * );
#define dfft_3d dfft_3d__
int dfft_3d__( char *, char *, char *, double *, double *, int *, int *, int *, 
	int *, int *, int *, int * );
#define dfft_init_3d dfft_init_3d__
int dfft_init_3d__( int *, int *, int *, DXML_D_FFT_STRUCTURE_3D *, int * );
#define dfft_apply_3d dfft_apply_3d__
int dfft_apply_3d__( char *, char *, char *, double *, double *, int *, int *, 
	DXML_D_FFT_STRUCTURE_3D *, int *, int *, int * );
#define dfft_exit_3d dfft_exit_3d__
int dfft_exit_3d__( DXML_D_FFT_STRUCTURE_3D * );
/*
**	Function type definition of the CONV/CORR routines
*/
#define cconv_nonperiodic cconv_nonperiodic__
void cconv_nonperiodic__( float *, float *, float *, int *, int *, int * );
#define cconv_nonperiodic_ext cconv_nonperiodic_ext__
int cconv_nonperiodic_ext__( float *, int *, float *, int *, float *, int *, int 
	*, int *, int *, int *, int *, int *, float *, int * );
#define cconv_periodic cconv_periodic__
void cconv_periodic__( float *, float *, float *, int *, int * );
#define cconv_periodic_ext cconv_periodic_ext__
int cconv_periodic_ext__( float *, int *, float *, int *, float *, int *, int *, 
	int *, int *, int *, int *, float *, int * );
#define ccorr_nonperiodic ccorr_nonperiodic__
void ccorr_nonperiodic__( float *, float *, float *, int *, int *, int * );
#define ccorr_nonperiodic_ext ccorr_nonperiodic_ext__
int ccorr_nonperiodic_ext__( float *, int *, float *, int *, float *, int *, int 
	*, int *, int *, int *, int *, int *, float *, int * );
#define ccorr_periodic ccorr_periodic__
void ccorr_periodic__( float *, float *, float *, int *, int * );
#define ccorr_periodic_ext ccorr_periodic_ext__
int ccorr_periodic_ext__( float *, int *, float *, int *, float *, int *, int *, 
	int *, int *, int *, int *, float *, int * );
#define zconv_nonperiodic zconv_nonperiodic__
void zconv_nonperiodic__( double *, double *, double *, int *, int *, int * );
#define zconv_nonperiodic_ext zconv_nonperiodic_ext__
int zconv_nonperiodic_ext__( double *, int *, double *, int *, double *, int *, 
	int *, int *, int *, int *, int *, int *, double *, int * );
#define zconv_periodic zconv_periodic__
void zconv_periodic__( double *, double *, double *, int *, int * );
#define zconv_periodic_ext zconv_periodic_ext__
int zconv_periodic_ext__( double *, int *, double *, int *, double *, int *, int 
	*, int *, int *, int *, int *, double *, int * );
#define zcorr_nonperiodic zcorr_nonperiodic__
void zcorr_nonperiodic__( double *, double *, double *, int *, int *, int * );
#define zcorr_nonperiodic_ext zcorr_nonperiodic_ext__
int zcorr_nonperiodic_ext__( double *, int *, double *, int *, double *, int *, 
	int *, int *, int *, int *, int *, int *, double *, int * );
#define zcorr_periodic zcorr_periodic__
void zcorr_periodic__( double *, double *, double *, int *, int * );
#define zcorr_periodic_ext zcorr_periodic_ext__
int zcorr_periodic_ext__( double *, int *, double *, int *, double *, int *, int 
	*, int *, int *, int *, int *, double *, int * );
#define sconv_nonperiodic sconv_nonperiodic__
void sconv_nonperiodic__( float *, float *, float *, int *, int *, int * );
#define sconv_nonperiodic_ext sconv_nonperiodic_ext__
int sconv_nonperiodic_ext__( float *, int *, float *, int *, float *, int *, int 
	*, int *, int *, int *, int *, int *, float *, int * );
#define sconv_periodic sconv_periodic__
void sconv_periodic__( float *, float *, float *, int *, int * );
#define sconv_periodic_ext sconv_periodic_ext__
int sconv_periodic_ext__( float *, int *, float *, int *, float *, int *, int *, 
	int *, int *, int *, int *, float *, int * );
#define scorr_nonperiodic scorr_nonperiodic__
void scorr_nonperiodic__( float *, float *, float *, int *, int *, int * );
#define scorr_nonperiodic_ext scorr_nonperiodic_ext__
int scorr_nonperiodic_ext__( float *, int *, float *, int *, float *, int *, int 
	*, int *, int *, int *, int *, int *, float *, int * );
#define scorr_periodic scorr_periodic__
void scorr_periodic__( float *, float *, float *, int *, int * );
#define scorr_periodic_ext scorr_periodic_ext__
int scorr_periodic_ext__( float *, int *, float *, int *, float *, int *, int *, 
	int *, int *, int *, int *, float *, int * );
#define dconv_nonperiodic dconv_nonperiodic__
void dconv_nonperiodic__( double *, double *, double *, int *, int *, int * );
#define dconv_nonperiodic_ext dconv_nonperiodic_ext__
int dconv_nonperiodic_ext__( double *, int *, double *, int *, double *, int *, 
	int *, int *, int *, int *, int *, int *, double *, int * );
#define dconv_periodic dconv_periodic__
void dconv_periodic__( double *, double *, double *, int *, int * );
#define dconv_periodic_ext dconv_periodic_ext__
int dconv_periodic_ext__( double *, int *, double *, int *, double *, int *, int 
	*, int *, int *, int *, int *, double *, int * );
#define dcorr_nonperiodic dcorr_nonperiodic__
void dcorr_nonperiodic__( double *, double *, double *, int *, int *, int * );
#define dcorr_nonperiodic_ext dcorr_nonperiodic_ext__
int dcorr_nonperiodic_ext__( double *, int *, double *, int *, double *, int *, 
	int *, int *, int *, int *, int *, int *, double *, int * );
#define dcorr_periodic dcorr_periodic__
void dcorr_periodic__( double *, double *, double *, int *, int * );
#define dcorr_periodic_ext dcorr_periodic_ext__
int dcorr_periodic_ext__( double *, int *, double *, int *, double *, int *, int 
	*, int *, int *, int *, int *, double *, int * );
/*
**	Function type definition of the CONV/CORR SIG routines
*/
/*
**	Function type definition of the CONV/CORR 2D routines
*/
/*
**	Function type definition of the SYM_TOEPLITZ routines
*/
/*
**	Function type definition of the FILTER routines
*/
#define sfilter_nonrec sfilter_nonrec__
void sfilter_nonrec__( float *, float *, int *, float *, float *, float *, int 
	*, int * );
#define sfilter_init_nonrec sfilter_init_nonrec__
void sfilter_init_nonrec__( int *, float *, float *, float *, int *, float *, 
	int * );
#define sfilter_apply_nonrec sfilter_apply_nonrec__
void sfilter_apply_nonrec__( float *, float *, float *, int * );
/*
**	Function type definition for the varying signature routines 
*/
#define cfft cfft_
int cfft_( char *, char *, char *, ... );
#define cfft_apply cfft_apply__
int cfft_apply__( char *, char *, char *, ... );
#define cfft_grp cfft_grp__
int cfft_grp__( char *, char *, char *, ... );
#define cfft_apply_grp cfft_apply_grp__
int cfft_apply_grp__( char *, char *, char *, ... );
#define cfft_2d cfft_2d__
int cfft_2d__( char *, char *, char *, ... );
#define cfft_apply_2d cfft_apply_2d__
int cfft_apply_2d__( char *, char *, char *, ... );
#define cfft_3d cfft_3d__
int cfft_3d__( char *, char *, char *, ... );
#define cfft_apply_3d cfft_apply_3d__
int cfft_apply_3d__( char *, char *, char *, ... );
#define zfft zfft_
int zfft_( char *, char *, char *, ... );
#define zfft_apply zfft_apply__
int zfft_apply__( char *, char *, char *, ... );
#define zfft_grp zfft_grp__
int zfft_grp__( char *, char *, char *, ... );
#define zfft_apply_grp zfft_apply_grp__
int zfft_apply_grp__( char *, char *, char *, ... );
#define zfft_2d zfft_2d__
int zfft_2d__( char *, char *, char *, ... );
#define zfft_apply_2d zfft_apply_2d__
int zfft_apply_2d__( char *, char *, char *, ... );
#define zfft_3d zfft_3d__
int zfft_3d__( char *, char *, char *, ... );
#define zfft_apply_3d zfft_apply_3d__
int zfft_apply_3d__( char *, char *, char *, ... );
#if defined(__cplusplus)
}
#endif
#endif
