/* File: cxml_dss.h */
/*
**  Copyright 2001 Compaq Computer Corporation
**
**  COMPAQ Registered in U.S. Patent and Trademark Office.
**
**  Confidential computer software.  Valid license from Compaq required for
**  possession, use or copying.  Consistent with FAR 12.211 and 12.212,
**  Commerical Computer Software, Computer Software Documentation, and
**  Technical Data for Commmerical Items are licensed to the U.S. Government
**  under vendor's standard commerical license.
**
**	Generated on: Tue Mar 27 21:17:19 2001
**
*/


#if !defined( __CXML_DSS_H )

#define __CXML_DSS_H 


#if !defined(__CxmlDoubleComplexType)
#   define __CxmlDoubleComplexType struct { double r, i; }
#endif

typedef void * _CXML_DSS_HANDLE_t;
typedef int        _INTEGER_t;
typedef float      _REAL_t;
typedef double     _DOUBLE_PRECISION_t;
typedef __CxmlDoubleComplexType _DOUBLE_COMPLEX_t;
#define CXML_DSS_DEFAULTS	0

/*
** Message level option definitions
*/

#define CXML_DSS_MSG_LVL_SUCCESS	-2147483647
#define CXML_DSS_MSG_LVL_DEBUG  	-2147483646
#define CXML_DSS_MSG_LVL_INFO   	-2147483645
#define CXML_DSS_MSG_LVL_WARNING	-2147483644
#define CXML_DSS_MSG_LVL_ERROR  	-2147483643
#define CXML_DSS_MSG_LVL_FATAL  	-2147483642

/*
** Termination level option definitions
*/

#define CXML_DSS_TERM_LVL_SUCCESS	1073741832
#define CXML_DSS_TERM_LVL_DEBUG  	1073741840
#define CXML_DSS_TERM_LVL_INFO   	1073741848
#define CXML_DSS_TERM_LVL_WARNING	1073741856
#define CXML_DSS_TERM_LVL_ERROR  	1073741864
#define CXML_DSS_TERM_LVL_FATAL  	1073741872

/*
** Structure option definitions
*/

#define CXML_DSS_SYMMETRIC          	536870976
#define CXML_DSS_SYMMETRIC_STRUCTURE	536871040
#define CXML_DSS_NON_SYMMETRIC      	536871104

/*
** Reordering option definitions
*/

#define CXML_DSS_AUTO_ORDER   	268435520
#define CXML_DSS_MY_ORDER     	268435584
#define CXML_DSS_OPTION1_ORDER	268435648

/*
** Factorization option definitions
*/

#define CXML_DSS_POSITIVE_DEFINITE          	134217792
#define CXML_DSS_INDEFINITE                 	134217856
#define CXML_DSS_HERMITIAN_POSITIVE_DEFINITE	134217920
#define CXML_DSS_HERMITIAN_INDEFINITE       	134217984

/*
** Return status values
*/

#define CXML_DSS_SUCCESS        	0
#define CXML_DSS_ZERO_PIVOT     	-1
#define CXML_DSS_OUT_OF_MEMORY  	-2
#define CXML_DSS_FAILURE        	-3
#define CXML_DSS_ROW_ERR        	-4
#define CXML_DSS_COL_ERR        	-5
#define CXML_DSS_TOO_FEW_VALUES 	-6
#define CXML_DSS_TOO_MANY_VALUES	-7
#define CXML_DSS_NOT_SQUARE     	-8
#define CXML_DSS_STATE_ERR      	-9
#define CXML_DSS_INVALID_OPTION 	-10
#define CXML_DSS_OPTION_CONFLICT	-11
#define CXML_DSS_MSG_LVL_ERR    	-12
#define CXML_DSS_TERM_LVL_ERR   	-13
#define CXML_DSS_STRUCTURE_ERR  	-14
#define CXML_DSS_REORDER_ERR    	-15
#define CXML_DSS_VALUES_ERR     	-16

/*
** Function prototypes for DSS routines
*/

extern _INTEGER_t dss_create__(_CXML_DSS_HANDLE_t *,
	 _INTEGER_t const *);
#define dss_create(handle, opt) dss_create__(&(handle), &(opt))
extern _INTEGER_t dss_define_structure__(_CXML_DSS_HANDLE_t *,
	 _INTEGER_t const *, _INTEGER_t const *, _INTEGER_t const *,
	 _INTEGER_t const *, _INTEGER_t const *, _INTEGER_t const *);
#define dss_define_structure(handle, opt, rowIndex, nRows, rCols,\
	 columns, nNonZeros) dss_define_structure__(&(handle), &(opt),\
	 (rowIndex), &(nRows), &(rCols), (columns), &(nNonZeros))
extern _INTEGER_t dss_reorder__(_CXML_DSS_HANDLE_t *, _INTEGER_t const *,
	 _INTEGER_t const *);
#define dss_reorder(handle, opt, perm) dss_reorder__(&(handle), &(opt),\
	 (perm))
extern _INTEGER_t dss_factor_real__(_CXML_DSS_HANDLE_t *,
	 _INTEGER_t const *, _DOUBLE_PRECISION_t const *);
#define dss_factor_real(handle, opt,\
	 rValues) dss_factor_real__(&(handle), &(opt), (rValues))
extern _INTEGER_t dss_factor_complex__(_CXML_DSS_HANDLE_t *,
	 _INTEGER_t const *, _DOUBLE_COMPLEX_t const *);
#define dss_factor_complex(handle, opt,\
	 rValues) dss_factor_complex__(&(handle), &(opt), (rValues))
extern _INTEGER_t dss_solve_real__(_CXML_DSS_HANDLE_t *,
	 _INTEGER_t const *, _DOUBLE_PRECISION_t const *, _INTEGER_t const *,
	 _DOUBLE_PRECISION_t *);
#define dss_solve_real(handle, opt, rRhsValues, nRhs,\
	 rSolValues) dss_solve_real__(&(handle), &(opt), (rRhsValues), &(nRhs),\
	 (rSolValues))
extern _INTEGER_t dss_solve_complex__(_CXML_DSS_HANDLE_t *,
	 _INTEGER_t const *, _DOUBLE_COMPLEX_t const *, _INTEGER_t const *,
	 _DOUBLE_COMPLEX_t *);
#define dss_solve_complex(handle, opt, rRhsValues, nRhs,\
	 rSolValues) dss_solve_complex__(&(handle), &(opt), (rRhsValues),\
	 &(nRhs), (rSolValues))
extern _INTEGER_t dss_delete__(_CXML_DSS_HANDLE_t const *,
	 _INTEGER_t const *);
#define dss_delete(handle, opt) dss_delete__(&(handle), &(opt))

#endif

